/*******************************************************************************
**3456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789
**      10        20        30        40        50        60        70        80
**
** digitally-imported-ui
**
** an UbuntuTouch frontend for DigitallyImported's music-service
**
** Copyright 2013 Mirco "MacSlow" Müller <macslow@gmail.com>
**
** This program is free software: you can redistribute it and/or modify it
** under the terms of the GNU General Public License version 3, as published
** by the Free Software Foundation.
**
** This program is distributed in the hope that it will be useful, but
** WITHOUT ANY WARRANTY; without even the implied warranties of
** MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
** PURPOSE.  See the GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License along
** with this program.  If not, see <http://www.gnu.org/licenses/>.
**
*******************************************************************************/

import QtQuick 2.0
import Ubuntu.Components 0.1
import Ubuntu.Components.ListItems 0.1 as ListItem
import Player 0.1

MainView {
    width: units.gu(40)
    height: units.gu(71)

    Player {
        id: mockPlayer

        onTitleChanged: {
            mockModel.get(channels.currentIndex).track = getCurrentTitle()
        }
    }

    ListModel {
        id: mockModel

        ListElement {
            icon: "http://static.audioaddict.com/9760862fcf5601c05c3581d6c0984128.png"
            title: "Ambient"
            description: "A blend of ambient, downtempo and chillout"
            track: ""
            uri: "http://pub7.di.fm:80/di_ambient_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/5/b/7/f/5/d/5b7f5db07bd3bc6e8097ea33bbea7552.png"
            title: "Bit Room House"
            description: "The most uplifting, floor-filling Big Room House!"
            track: ""
            uri: "http://pub2.di.fm:80/di_bigroomhouse_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/5fe8da68c08afeba771f1c0a5ba6bc2f.png"
            title: "Breaks"
            description: "A fine assortment of trance and house breaks"
            track: ""
            uri: "http://pub6.di.fm:80/di_breaks_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/8f7ce44aa749a97563c98dc5b69053aa.png"
            title: "Chillout"
            description: "Full of trippy flavours, this channel is just what you need to relax."
            track: ""
            uri: "http://pub4.di.fm:80/di_chillout_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/7a0a070cca01976ea62c9e1c5a19e9b1.png"
            title: "Chillout Dreams"
            description: "Relax to the sounds of dream and Ibiza style chillout"
            track: ""
            uri: "http://pub4.di.fm:80/di_chilloutdreams_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/ab17e2f15ebe382d78d744726408b668.png"
            title: "Chiptunes"
            description: "Playing the best chiptunes and video game music."
            track: ""
            uri: "http://pub4.di.fm:80/di_chiptunes_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/a272766a55dc1d3c5b63e688d7a3d0de.png"
            title: "Classic EuroDance"
            description: "The finest imported cheese on the net!"
            track: ""
            uri: "http://pub6.di.fm:80/di_classiceurodance_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/f/9/c/6/c/d/f9c6cdb880da74aa74ec581dc3f09dbd.png"
            title: "Classic EuroDisco"
            description: "Relive the sounds of Euro & Italo Disco."
            track: ""
            uri: "http://pub2.di.fm:80/di_classiceurodisco_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/53906dc786e7f3d55536defca56a4b5f.png"
            title: "Classic Trance"
            description: "Relive the classic trance hits!"
            track: ""
            uri: "http://pub4.di.fm:80/di_classictrance_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/6c59bb5709a2e2ecae99765d64ce57e6.png"
            title: "Classic Vocal Trance"
            description: "Classic sounds of Vocal Trance"
            track: ""
            uri: "http://pub4.di.fm:80/di_classicvocaltrance_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/29b1b727e81f9dc1c6ca40926ac8ae34.jpg"
            title: "Club Dubstep"
            description: "Bass fuelled, club shaking Dubstep."
            track: ""
            uri: "http://pub4.di.fm:80/di_clubdubstep_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/6620a82bb6a6d0bc281260645b996b0a.png"
            title: "Club Sounds"
            description: "The hottest club and dance tunes 24/7"
            track: ""
            uri: "http://pub6.di.fm:80/di_clubsounds_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/e98aea320629ce07814e0546f7c39ba1.png"
            title: "Cosmic Downtempo"
            description: "A downtempo journey into the cosmos"
            track: ""
            uri: "http://pub4.di.fm:80/di_cosmicdowntempo_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/5a0a6603d9a3f151b9eced1629e77d66.png"
            title: "DJ Mixes"
            description: "Non-stop DJ set featuring various forms of techno & trance!"
            track: ""
            uri: "http://pub4.di.fm:80/di_djmixes_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/1/5/6/1/b/a/1561ba009eb79c68b9de141f8685c927.png"
            title: "Dark DnB"
            description: "A twisted blend of heavy hitting Dark Drum and Bass!"
            track: ""
            uri: "http://pub7.di.fm:80/di_darkdnb_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/8dd90c88b4ee5399e6182204a2ede8ed.jpg"
            title: "Deep House"
            description: "Only the sexiest, silky smooth and groovy Deep House."
            track: ""
            uri: "http://pub6.di.fm:80/di_deephouse_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/3896ecff86795302304c64386ff2c5db.png"
            title: "Deep NuDisco"
            description: "Slo-mo house with ear perking space disco and low-slung bass beats!"
            track: ""
            uri: "http://pub4.di.fm:80/di_deepnudisco_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/8/7/d/3/b/2/87d3b2ee913e6ac75882329971d58be4.png"
            title: "Deep Tech"
            description: "Deeper shades of house and techno with dub and blues influences."
            track: ""
            uri: "http://pub4.di.fm:80/di_deeptech_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/0ea9396414430256ffb76cd6148bf88a.png"
            title: "Disco House"
            description: "The grooviest Disco House tunes on the web."
            track: ""
            uri: "http://pub7.di.fm:80/di_discohouse_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/f2ed26a932bdb5cd0a0eac576aebfa3f.png"
            title: "Drum 'n Bass"
            description: "Tasty assortment to satisfy your drum and bass fix!"
            track: ""
            uri: "http://pub4.di.fm:80/di_drumandbass_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/e0614d304c8fd5879a1278dd626d8769.png"
            title: "Dubstep"
            description: "Dubstep hits and mixes!!!"
            track: ""
            uri: "http://pub4.di.fm:80/di_dubstep_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/2/5/f/5/5/9/25f559a97855d8107e7cdc63f2acb345.png"
            title: "EcLectronica"
            description: "An eclectic mixture of modern electronica."
            track: ""
            uri: "http://pub2.di.fm:80/di_eclectronica_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/387bfe3c7d50b4edd1408135596a03df.png"
            title: "Electro House"
            description: "An eclectic mix of electro and dirty house"
            track: ""
            uri: "http://pub6.di.fm:80/di_electrohouse_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/5a76739725cd2106a3e2f30a1461a9bd.jpg"
            title: "Epic Trance"
            description: "The best in uplifting and euphoric Trance"
            track: ""
            uri: "http://pub7.di.fm:80/di_epictrance_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/a42ae2b9810acb81c6003915113c7d9d.png"
            title: "EuroDance"
            description: "The newest and best of Eurodance hits"
            track: ""
            uri: "http://pub7.di.fm:80/di_eurodance_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/45d5aa9e246fd59fe03e601171059581.png"
            title: "Funky House"
            description: "A fine selection of funky mouse music!!"
            track: ""
            uri: "http://pub6.di.fm:80/di_funkyhouse_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/f4b0f3c30b34cf76de0955652ae5664a.png"
            title: "Future Synthpop"
            description: "Finest selection of futurepop and synthpop!!"
            track: ""
            uri: "http://pub7.di.fm:80/di_futuresynthpop_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/e/a/6/4/7/f/ea647f64af96d86d206bc0a575e4e63b.png"
            title: "Glitch Hop"
            description: "Bit-crushing, dub-infused Hip Hop sounds!"
            track: ""
            uri: "http://pub3.di.fm:80/di_glitchhop_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/b5b22bf5232f246bf63b25914bd369e3.png"
            title: "Goa-Psy Trance"
            description: "A psychedelic voyage out of this world!"
            track: ""
            uri: "http://pub4.di.fm:80/di_goapsy_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/9d04d9b20de5378994fa8653a1dc69f3.jpg"
            title: "Hands Up"
            description: "Hands Up beats blending harder dance, trance and happy hardcore"
            track: ""
            uri: "http://pub6.di.fm:80/di_handsup_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/a67b19cab6cdb97ec77f8264f9c4c562.png"
            title: "Hard Dance"
            description: "Enjoy the harder side of throbbing house and trance."
            track: ""
            uri: "http://pub4.di.fm:80/di_harddance_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/14f1a4484dc88e0df006e9cd71407bcb.png"
            title: "Hardcore"
            description: "DJ mixes, hard dance and NuNRG"
            track: ""
            uri: "http://pub4.di.fm:80/di_hardcore_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/b27a7b020806ce4428307b30b44734ec.png"
            title: "Hardstyle"
            description: "Banging Hardstyle for your ears!!!"
            track: ""
            uri: "http://pub4.di.fm:80/di_hardstyle_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/6f8a0b3279c24b1c5fa1c6c1397b9b56.png"
            title: "House"
            description: "Silky sexy deep house music direct from New York city!"
            track: ""
            uri: "http://pub6.di.fm:80/di_house_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/fb8908953ab95d2f01402660e2cc0883.png"
            title: "Latin House"
            description: "Finest selection of Latin house!!"
            track: ""
            uri: "http://pub4.di.fm:80/di_latinhouse_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/75b2b5e697e7948f5fcd64a1c54f3f72.png"
            title: "Liquid DnB"
            description: "Flowing with the freshest Liquid DnB!!"
            track: ""
            uri: "http://pub4.di.fm:80/di_liquiddnb_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/d/f/2/5/8/a/df258a92e9d5152cb182b439f1d0eb2b.png"
            title: "Liquid Dubstep"
            description: "Mellow out to the rolling, soothing deep bass of Liquid Dubstep."
            track: ""
            uri: "http://pub3.di.fm:80/di_liquiddubstep_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/58f7afca5a6883c063f8642bfd2cef80.png"
            title: "Lounge"
            description: "Sit back and enjoy the lounge grooves!"
            track: ""
            uri: "http://pub4.di.fm:80/di_lounge_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/5/b/a/f/e/3/5bafe3802484d479d77b21aa34f537fe.png"
            title: "Mainstage"
            description: "The biggest DJs from the best festivals around the world!"
            track: ""
            uri: "http://pub5.di.fm:80/di_mainstage_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/5c29e3063f748d156260fb874634b602.png"
            title: "Minimal"
            description: "Finest selection of Minimal Techno & House!!"
            track: ""
            uri: "http://pub7.di.fm:80/di_minimal_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/7edf76e784f740c1a20904309bbc7080.png"
            title: "Oldschool Acid"
            description: "Oldschool sounds of Acid Techno, House and Trance!"
            track: ""
            uri: "http://pub4.di.fm:80/di_oldschoolacid_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/ad112b71e9682c79343a4df45d419297.png"
            title: "Oldschool Electronica"
            description: "old school techno, trance & rave!"
            track: ""
            uri: "http://pub1.di.fm:80/di_oldschoolelectronica_aacplus"
        }

        ListElement{
            icon: "http://static.audioaddict.com/fcea7c9d9a16314103a41f66bd6dfd15.png"
            title: "Progressive"
            description: "House, techno and trance beats for your mind!"
            track: ""
            uri: "http://pub4.di.fm:80/di_progressive_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/4aeae25360c3792e8e9fd6f2e5cdf39e.jpg"
            title: "Progressive Psy"
            description: "Progress you mind to undiscovered psychedelic dimensions."
            track: ""
            uri: "http://pub4.di.fm:80/di_progressivepsy_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/3/b/2/e/1/3/3b2e1348eb2ded04b1b97e1791001bf8.png"
            title: "Russian Club Hits"
            description: "Russia's hottest club hits."
            track: ""
            uri: "http://pub5.di.fm:80/di_russianclubhits_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/950ff823b9989f18f19ba65fb149fcad.png"
            title: "Soulful House"
            description: "House music selected from Paris with love!"
            track: ""
            uri: "http://pub2.di.fm:80/di_soulfulhouse"
        }

        ListElement {
            icon: "http://static.audioaddict.com/4531d1656bc302d4f1898f779a988c17.png"
            title: "Space Dreams"
            description: "Ambient space music for expanding minds"
            track: ""
            uri: "http://pub4.di.fm:80/di_spacemusic_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/a1cb226c2170a74ed0fdb4839dafe869.png"
            title: "Tech House"
            description: "A fusion of techno and house with a deep, soulful vibe."
            track: ""
            uri: "http://pub4.di.fm:80/di_techhouse_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/cedaa3b495a451bdd6ee4b21311e155c.png"
            title: "Techno"
            description: "From Minimal to Detroit to Schranz & all in between!"
            track: ""
            uri: "http://pub4.di.fm:80/di_techno_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/befc1043f0a216128f8570d3664856f7.png"
            title: "Trance"
            description: "Full of trippy flavour, this channel is just what you need to relax."
            track: ""
            uri: "http://pub4.di.fm:80/di_trance_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/4af36061eb3e97a0aa21b746b51317dd.png"
            title: "Tribal House"
            description: "Finest selection of tribal and tech house!!"
            track: ""
            uri: "http://pub7.di.fm:80/di_tribalhouse_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/c0ce1fbfe33a144e298d1bbec53406a3.png"
            title: "UK Garage"
            description: "The latest and greatest in UK Garage!!"
            track: ""
            uri: "http://pub4.di.fm:80/di_ukgarage_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/6/9/1/2/a/4/6912a40c6004918029a91b804944ffd5.png"
            title: "UMF Radio"
            description: "UMF Radio 24/7"
            track: ""
            uri: "http://pub5.di.fm:80/di_umfradio_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/a5b0bd27de43d04e1da9acf5b8883e85.png"
            title: "Vocal Chillout"
            description: "Enjoy the relaxing vocal sounds of Ibiza chillout"
            track: ""
            uri: "http://pub4.di.fm:80/di_vocalchillout_aacplus"
        }

        ListElement {
            icon: "http://static.audioaddict.com/009b4fcdb032cceee6f3da5efd4a86e9.png"
            title: "Vocal Trance"
            description: "A fusion of trance, dance and chilling vocals together!"
            track: ""
            uri: "http://pub4.di.fm:80/di_vocaltrance_aacplus"
        }
    }

    Component {
        id: highlight

        UbuntuShape {
            width: units.gu(39)
            color: "#dd4814"
            y: channels.currentIndex !== -1 ? channels.currentItem.y : 0
            Behavior on y {
                SpringAnimation {
                    spring: 3
                    damping: 0.2
                }
            }
        }
    }

    Tabs {
        Tab {
            title: "Channels"

            page: Page {
                ListView {
                    id: channels
                    anchors.fill: parent
                    anchors.margins: units.gu(.5)
                    model: mockModel
                    currentIndex: -1
                    highlightFollowsCurrentItem: true
                    highlight: highlight
                    delegate: Channel {
                        icon: model.icon
                        title: model.title
                        description: model.description
                        track: model.track
                        player: mockPlayer
                        view: channels
                        textColor: Qt.darker("#aea79f", 1.3)
                    }
                }
            }
        }

        Tab {
            title: "Shows"

            page: Page {
                Label {
                    anchors.centerIn: parent
                    text: "to be implemented"
                    fontSize: "large"
                }
            }
        }

        Tab {
            title: "Community"

            page: Page {
                Label {
                    anchors.centerIn: parent
                    text: "to be implemented"
                    fontSize: "large"
                }
            }
        }

        Tab {
            title: "Premium"

            page: Page {
                Label {
                    anchors.centerIn: parent
                    text: "to be implemented"
                    fontSize: "large"
                }
            }
        }
    }
}
