/*******************************************************************************
**3456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789
**      10        20        30        40        50        60        70        80
**
** digitally-imported-ui
**
** an UbuntuTouch frontend for DigitallyImported's music-service
**
** Copyright 2013 Mirco "MacSlow" Müller <macslow@gmail.com>
**
** This program is free software: you can redistribute it and/or modify it
** under the terms of the GNU General Public License version 3, as published
** by the Free Software Foundation.
**
** This program is distributed in the hope that it will be useful, but
** WITHOUT ANY WARRANTY; without even the implied warranties of
** MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
** PURPOSE.  See the GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License along
** with this program.  If not, see <http://www.gnu.org/licenses/>.
**
*******************************************************************************/

#ifndef _PLAYER_H_
#define _PLAYER_H_

#include <QObject>
#include <QString>
#include <gst/gst.h>

class Player : public QObject
{
	Q_OBJECT

	public:
		Player (QObject* parent = 0);
		~Player ();

		Q_INVOKABLE void play (QString uri);
		Q_INVOKABLE void stop ();
		Q_INVOKABLE void crossfade (QString uri);
		Q_INVOKABLE void setCurrentTitle (QString title);
		Q_INVOKABLE QString getCurrentTitle ();

    Q_SIGNALS:
    	void titleChanged();

	private:
		GstElement* _playbin2;
		GstBus*     _bus;
		QString     _title;
};

#endif // _PLAYER_H_
